import { ID, Int, PartialBoolean } from "../types";
export type Variables = {
    [key: string]: any;
};
export interface RequestOptions {
    name: string;
    query: string;
    parameters: string[];
    variables: Variables;
}
export declare abstract class AbstractClient {
    protected abstract _request<T>(options: RequestOptions): Promise<T>;
    protected _list<T>(options: __InternalOptions<ByArray<any, any>, T>): RequestOptions;
    protected _byId<T>(id: ID, fields: PartialBoolean<T>, name: string): RequestOptions;
    protected _connection<T>(fields: PartialBoolean<T>, options: any, name: string): RequestOptions;
    private static normalizeFields;
}
type __InternalOptions<T, R> = T & {
    name: string;
    entity: string;
    fields: PartialBoolean<R>;
};
export type ByIdOptions = {
    id: ID;
};
export type ByArray<OrderBy extends string = "", Where extends object = {}> = {
    limit?: Int;
    offset?: Int;
    orderBy?: `${OrderBy}_${"ASC" | "DESC"}`[];
    where?: Where;
};
export type ByConnection<OrderBy extends string = "", Where extends object = {}> = {
    after?: string;
    first?: Int;
    orderBy: OrderBy[];
    where?: Where;
};
export {};
//# sourceMappingURL=abstract_client.d.ts.map