import { AbstractClient, RequestOptions } from "./abstract_client";
import { ByIdQueries } from "./by_id_queries";
import { ConnectionQueries } from "./connection_queries";
import { ListQueries } from "./list_queries";
type _Merge = ListQueries & ByIdQueries & ConnectionQueries;
export type MergableQuery = {
    [K in keyof _Merge]?: Parameters<_Merge[K]>;
};
export declare class TFGridGqlClient extends AbstractClient {
    private readonly __uri;
    constructor(url: string);
    protected _request<T>(options: RequestOptions): Promise<T>;
    merge<T extends MergableQuery>(queries: T): Promise<NormalizeMerge<T>>;
}
type NormalizeMerge<T> = {
    [K in keyof T]: K extends keyof ListQueries ? ReturnType<ListQueries[K]> extends Promise<Array<infer Q>> ? Q[] : unknown : K extends keyof ByIdQueries ? ReturnType<ByIdQueries[K]> extends Promise<infer Q> ? Q : unknown : K extends keyof ConnectionQueries ? ReturnType<ConnectionQueries[K]> extends Promise<infer Q> ? Q : unknown : unknown;
};
export interface TFGridGqlClient extends ListQueries, ByIdQueries, ConnectionQueries {
}
export {};
//# sourceMappingURL=client.d.ts.map